﻿package Print2Flash {
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.utils.*;
	import flash.system.*;
	
	public class Print2FlashDoc3 extends Loader {
		private var contentwidth,contentheight:Number
		private var loadTimer:Timer	
		public static const ONLOADEVENT:String="onLoaded"

		private const LOADDIRECTLY:int = 0;
		private const LOADBYTES:int = 1;
		private var loadMethod:int=LOADDIRECTLY;

		public function Print2FlashDoc3(url:String,x:Number,y:Number,width:Number,height:Number,parent:DisplayObjectContainer):void {
			loadTimer=new Timer(10)
			loadTimer.addEventListener("timer", checkLoaded);
			this.x=x
			this.y=y
			contentwidth=width;
			contentheight=height;
			loadDoc(url);
			parent.addChild(this);
		}
		
		public function loadDoc(url:String):void {
			visible=false
			try {
				Security.allowDomain("*")
			}
			catch (e:Error) {
			}

			if (loadMethod==LOADBYTES) {
				var urlLoader:URLLoader = new URLLoader(new URLRequest(url)); 
				urlLoader.dataFormat=URLLoaderDataFormat.BINARY;
				urlLoader.addEventListener(Event.COMPLETE,onURLLoaded);
			} else {
				load(new URLRequest(url));
				loadTimer.start();
			}
		}
		
		private function onURLLoaded(event:Event):void {
			var loaderContext:LoaderContext = new LoaderContext();  
			loaderContext["allowCodeImport"] = true;  
			loadBytes((event.target as URLLoader).data, loaderContext);  			
			loadTimer.start();
		}
		
	    public function checkLoaded(event:TimerEvent):void {
			var doc:MovieClip=getDoc();
			if (doc && doc.DocArea) {
				doc.init(contentwidth,contentheight)
				loadTimer.stop();
				visible=true
				dispatchEvent(new Event(ONLOADEVENT))
			}
        }

		public function getDoc():MovieClip {
			return content as MovieClip
		}
	
	}
}